from common import *
import xml.sax
from PropertyRecord import *
class SmlngHandler(xml.sax.ContentHandler):

  validTags = baseTags + numbers

  def __init__(self, output):
    self.root = PropRoot("SMLNG")
    self.stack = [self.root]
    self.output = output #used for log/debug

  def emit(self, msg):
    print >>self.output, msg

  def makeContext(self, name):
    pr = PropertyRecord(name, parent=self.stack[-1])
    self.stack.append(pr)
    return pr

  def releaseContext(self, name):
    pr = self.stack.pop()
    if pr.name != name:
      raise SystemExit("Illegal nesting in doc. Not well formed: got %s, expected %s" % (name, pr.name))

  def _mapElement(self, name):
    if name in numbers:
      name = numbers.index(name)
    return name

  def _checkTag(self, name):
    if name == SPECIAL_TAG:
      return IGNORE

    if name not in self.validTags:
      fatal("invalid input: unknown tag(%s)" % name)

  def startElement(self, name, attrs):
    if self._checkTag(name) == IGNORE: return
    # Each element starts a new context
    name = self._mapElement(name)
    context = self.makeContext(name)
    context.setProp(name, 1)

  def endElement(self, name):
    if self._checkTag(name) == IGNORE: return
    name = self._mapElement(name)
    self.releaseContext(name)

  def characters(self, content):
    context = self.makeContext(TEXT)
    context.setData(content)
    self.releaseContext(TEXT)

