import sys
import time

SPECIAL_TAG = "SMLNG"
IGNORE      = "ignore"
TEXT        = "TEXT"


baseTags = [
  "B", "EM", "I", "PL", "S", "TT", "U",
  "r", "g", "b", "c", "m", "y", "k", "w"
    ]

raw_numbers = ["0", "1", "2", "3", "4", "5", "6", "7", "8", "9"]

numbers = [  "zero", "one", "two", "three", "four",
             "five", "six", "seven", "eight", "nine"]

smlngtags = baseTags + raw_numbers


### IO/Logging
def emit(msg):
  print >>sys.stdout, msg

def warn(msg):
  print >>sys.stderr, "%s: %s" %(time.ctime(time.time()), msg)

def fatal(msg):
  warn(msg)
  warn("Aborting on fatal error")
  sys.exit(1)

def getProp(node):
  return node.data

#Basic tree Node
class Node:

  def __init__(self):
    self.children = None
    self.parent = None

  def addChild(self, child):
    if self.children is None:
      self.children = []
    self.children.append(child)
    child.parent = self

