#!/usr/bin/env python
import urllib
import webbrowser
import tempfile
import string, re
import sys

# Here is how it works:
# Call SMLSyntaxValidate(yourdoc) to validate.
# Call SMLEquivalenceValidate(doc1, doc2) to compare.
# pass keyword arg "view=1" to open result in a browser
# pass keyword arg "verbose=1" to have it print result to stdout
# return is 1 on valid, 0 on nonvalid, -1 on error


fm_action  = "/bin/validate"
fm_method  = "post"

def SMLSyntaxValidate(chkdoc, url="http://cristal.inria.fr/bin/validate", view=None, verbose=None):
    # doc = "document=%s" % chkdoc
    doc = urllib.urlencode({'document': chkdoc})
    return SMLValidate(doc, url, view, verbose)

def SMLEquivalenceValidate(chk1, chk2, url="http://cristal.inria.fr/bin/compare", view=None, verbose=None):
    #doc = "documentone=%s&documenttwo=%s" % (chk1, chk2)
    doc = urllib.urlencode({ 'documentone': chk1, 'documenttwo': chk2 })
    return SMLValidate(doc, url, view, verbose)

def SMLValidate(doc, url, view=None, verbose=None):
    f = urllib.urlopen(url, doc)
    o = tempfile.mktemp(".html")
    of = open(o, "w")
    print >>of, f.read()
    of.close()
    if view == 1:
        webbrowser.open("file://%s" % o)
    return checkreturn(o, url, verbose)

def checkreturn(o, url, verbose=None):
    if re.compile("bin/validate").search(url) is not None:
        # they validated
        return checkvalid(o, verbose)
    elif re.compile("bin/compare").search(url) is not None:
        # they compared
        return checkequiv(o, verbose)
    else:
        print >>sys.stderr, "check matched neither /bin/validate nor /bin/compare?"
        return -1

def checkvalid(o, verbose=None):
    f = open(o,"r")
    if (string.find(f.read(), "your file appears to be valid") >= 0):
        if verbose:
            print "Valid."
        f.close()
        return 1
    else:
        if verbose:
            print "Not valid."
        f.close()
        return 0

def checkequiv(o, verbose=None):
    f = open(o,"r")
    if (string.find(f.read(), "Documents are equivalent") >= 0):
        if verbose:
            print "Equivalent."
        f.close()
        return 1
    else:
        if verbose:
            print "Not equivalent."
        f.close()
        return 0

# simple test
if __name__ == "__main__":
    SMLSyntaxValidate("foo<b>bar</b>", verbose=1)
    SMLSyntaxValidate("foo<b>bar<r>baz</b>gleep</r>")
    #SMLEquivalenceValidate(" <r> xxx </r><b> yyy  </b>", "<r> xxx  <b> yyy </b></r>")
